#!/usr/bin/env python3

import sys

def sortData(filename, size, space):
    try:
        f = open(filename, 'r')
    except IOError as e:
        errno, strerror = e.args
        print("I/O error({0}): {1}".format(errno,strerror))
    
    data = {}
    for line in f:
        line = line.rstrip()
        value = int(line)
        if (value >= space) and (value < space+size):
            key = value
            data[key] = 1
    
    for x in range(space, space+size):
        if x in data:
            print(x)

if len(sys.argv) == 3:
    size = int(sys.argv[1])
    filename = sys.argv[2]
else:
    print("Not enough arguments!")
    sys.exit(0)

try:
    f = open(filename, 'r')
except IOError as e:
    errno, strerror = e.args
    print("I/O error({0}): {1}".format(errno,strerror))

first = True

for line in f:
    line = line.rstrip()
    value = int(line)
    if(first):
        min = value
        max = value
        first = False
    else:
        if value < min:
            min = value
        if value > max:
            max = value
    
print(min, max)

numberOfPasses = int( (max - min) / size) + 1
print("Passes:", numberOfPasses)

i = 0
while i <= numberOfPasses:
    sortData(filename, size, min+i*size)
    i = i + 1